/*
 * Copyright (c) 1998-2005 Jitterbit, Inc.
 *
 */
package org.jitterbit.util.collections;

import java.util.ArrayList;
import java.util.List;

/**
 * @author frank
 *
 */
public class TreeItem<T> {
//	private TreeItem<T> m_parent;
	private String m_name;
	private List<TreeItem<T>>m_children=new ArrayList<TreeItem<T>>();
	private List<T> m_obj;
	
	TreeItem(String name){
//		m_parent=null;
		m_name=name;
		m_obj=new ArrayList<T>();
	}
	
	boolean hasChild(TreeItem<T> child0){
		for(TreeItem child:m_children){
			if(child==child0)return true;
		}
		return false;
	}
	
	void addChild(TreeItem<T> child){
		m_children.add(child);
//		child.m_parent=this;
	}
	
//	public TreeItem<T> getParent(){
//		return m_parent;
//	}
	
	public String getName(){
		return m_name;
	}
	
	public List<T> getData(){
		return m_obj;
	}
	
	public List<TreeItem<T>> getChildren(){
		return new ArrayList<TreeItem<T>>(m_children);
	}
	public boolean removeChild(TreeItem<T>child){
		return m_children.remove(child);
	}
	public void add(T a){
		m_obj.add(a);
	}
	public void print(String header){
		System.out.println(header+m_name);
		String header1=header+"    ";
		for(TreeItem<T>child:m_children){
			child.print(header1);
		}
	}
}
